#ifndef hpp_pinocchio_idl__robots_hxx__
#define hpp_pinocchio_idl__robots_hxx__

//
// Implemention of IDL interfaces in file /local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-4.8.0/idl/hpp/pinocchio_idl/robots.idl
//

#include <hpp/pinocchio_idl/robots-fwd.hh>

#include <sstream>

#include <hpp/corbaserver/fwd.hh>
#include <hpp/corbaserver/conversions.hh>
#include "hpp/corbaserver/servant-base.hh"

namespace hpp {

namespace corbaServer {

//
// Implementational code for IDL interface hpp::pinocchio_idl::CenterOfMassComputation
//
namespace pinocchio_impl {
template <typename _Base, typename _Storage>
CenterOfMassComputationServant<_Base, _Storage>::CenterOfMassComputationServant(Server* server, const _Storage& s)
  : ServantBase<hpp::pinocchio::CenterOfMassComputation, _Storage> (server, s)
{
  // add extra constructor code here
}
template <typename _Base, typename _Storage>
CenterOfMassComputationServant<_Base, _Storage>::~CenterOfMassComputationServant()
{
  // add extra destructor code here
}

//   Methods corresponding to IDL attributes and operations

template <typename _Base, typename _Storage>
void CenterOfMassComputationServant<_Base, _Storage>::compute ()
{
  try {
    // automatically generated code.
    
     (getT()->compute ());
    
    
  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
hpp::floatSeq* CenterOfMassComputationServant<_Base, _Storage>::com ()
{
  try {
    // automatically generated code.
    
    hpp::floatSeq* __return__ = hpp::corbaServer::vectorToFloatSeq (getT()->com ());
    
    return __return__;
  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
hpp::value_type CenterOfMassComputationServant<_Base, _Storage>::mass ()
{
  try {
    // automatically generated code.
    
    hpp::value_type __return__ (getT()->mass ());
    
    return __return__;
  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
hpp::floatSeqSeq* CenterOfMassComputationServant<_Base, _Storage>::jacobian ()
{
  try {
    // automatically generated code.
    
    hpp::floatSeqSeq* __return__ = hpp::corbaServer::matrixToFloatSeqSeq (getT()->jacobian ());
    
    return __return__;
  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

// End of implementational code
} // namespace pinocchio_impl

//
// Implementational code for IDL interface hpp::pinocchio_idl::Device
//
namespace pinocchio_impl {
template <typename _Base, typename _Storage>
DeviceServant<_Base, _Storage>::DeviceServant(Server* server, const _Storage& s)
  : ServantBase<hpp::pinocchio::Device, _Storage> (server, s)
{
  // add extra constructor code here
}
template <typename _Base, typename _Storage>
DeviceServant<_Base, _Storage>::~DeviceServant()
{
  // add extra destructor code here
}

//   Methods corresponding to IDL attributes and operations

template <typename _Base, typename _Storage>
char* DeviceServant<_Base, _Storage>::name ()
{
  try {
    // automatically generated code.
    
    char* __return__ = ::hpp::corbaServer::c_str (getT()->name ());
    
    return __return__;
  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
void DeviceServant<_Base, _Storage>::integrate (const hpp::floatSeq& config_in, const hpp::floatSeq& velocity, hpp::floatSeq_out result)
{
  try {
    // generated from /local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-4.8.0/idl/hpp/pinocchio_idl/robots.idl:27
    hpp::pinocchio::DevicePtr_t d = getT();
    hpp::pinocchio::Configuration_t res (d->configSize());
    hpp::pinocchio::integrate<false, hpp::pinocchio::DefaultLieGroupMap> (d,
      floatSeqToVector(config_in, d->configSize()),
      floatSeqToVector(velocity , d->numberDof()),
      res);
    result = vectorToFloatSeq (res);

  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
void DeviceServant<_Base, _Storage>::difference (const hpp::floatSeq& q1, const hpp::floatSeq& q2, hpp::floatSeq_out result)
{
  try {
    // generated from /local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-4.8.0/idl/hpp/pinocchio_idl/robots.idl:27
    hpp::pinocchio::DevicePtr_t d = getT();
    hpp::pinocchio::Configuration_t res (d->numberDof());
    hpp::pinocchio::difference<hpp::pinocchio::DefaultLieGroupMap> (d,
      floatSeqToVector(q1, d->configSize()),
      floatSeqToVector(q2, d->configSize()),
      res);
    result = vectorToFloatSeq (res);

  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
void DeviceServant<_Base, _Storage>::interpolate (const hpp::floatSeq& q1, const hpp::floatSeq& q2, ::CORBA::Float u, hpp::floatSeq_out result)
{
  try {
    // generated from /local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-4.8.0/idl/hpp/pinocchio_idl/robots.idl:27
    hpp::pinocchio::DevicePtr_t d = getT();
    hpp::pinocchio::Configuration_t res (d->configSize());
    hpp::pinocchio::interpolate<hpp::pinocchio::DefaultLieGroupMap> (d,
      floatSeqToVector(q1, d->configSize()),
      floatSeqToVector(q2, d->configSize()),
      u,
      res);
    result = vectorToFloatSeq (res);

  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

template <typename _Base, typename _Storage>
void DeviceServant<_Base, _Storage>::saturate (const hpp::floatSeq& qin, hpp::floatSeq_out qout, hpp::boolSeq_out saturation)
{
  try {
    // generated from /local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-4.8.0/idl/hpp/pinocchio_idl/robots.idl:27
    hpp::pinocchio::DevicePtr_t d = getT();
    hpp::pinocchio::Configuration_t q (floatSeqToVector(qin));
    hpp::pinocchio::ArrayXb sat (d->numberDof());
    hpp::pinocchio::saturate (d, q, sat);
    qout = vectorToFloatSeq (q);
    saturation = toBoolSeq(sat.data(), sat.data()+sat.size());

  } catch (const std::exception& e) {
    throw ::hpp::Error (e.what());
  }
}

// End of implementational code
} // namespace pinocchio_impl



} // namespace hpp

} // namespace corbaServer

#endif // hpp_pinocchio_idl__robots_hxx__

